package practice2;

/**
 * JavaBean zapouzdrujici informace o prevadenych castkach a menach
 * Implementace neni prilis dobra - bylo by treba, aby soucasne s daty
 * byla zapouzdrena i logika prevadeni (ta je ted castecne v EJB a castecne
 * v controlleru webove aplikace)
 */
public class Transaction {
    /** prevadena castka **/
    private double srcAmount;
    /** prevadena mena **/
    private Currency srcCurrency;
    /** vysledna castka **/
    private double dstAmount;
    /** vysledna mena */
    private Currency dstCurrency;

    /**
     * @return vysledna castka
     */
    public double getDstAmount() {
        return dstAmount;
    }

    /**
     * nastavuje vyslednou castku
     * @param dstAmount
     */
    public void setDstAmount(double dstAmount) {
        this.dstAmount = dstAmount;
    }

    /**
     * @return vysledna mena
     */
    public Currency getDstCurrency() {
        return dstCurrency;
    }

    /**
     * nastavuje vyslednou menu
     * @param dstCurrency - vysledna mena
     */
    public void setDstCurrency(Currency dstCurrency) {
        this.dstCurrency = dstCurrency;
    }

    /**
     * @return vyslednou castku
     */
    public double getSrcAmount() {
        return srcAmount;
    }

    /**
     * nastavuje prevadenou castku
     * @param srcAmount - prevadena castka
     */
    public void setSrcAmount(double srcAmount) {
        this.srcAmount = srcAmount;
    }

    /**
     * @return prevadenou castku
     */
    public Currency getSrcCurrency() {
        return srcCurrency;
    }

    /**
     * nastavuje prevadenou menu
     * @param srcCurrency - prevadena mena
     */
    public void setSrcCurrency(Currency srcCurrency) {
        this.srcCurrency = srcCurrency;
    }

    @Override
    public String toString() {
        return "" + srcAmount + " " + srcCurrency + " -> " + dstAmount + " " + dstCurrency;
    }

    /**
     * jednoduchy test funkcnosti - metoda umoznuje tridu spustit
     * @param args - zadne se nezpracovavaji
     */
    public static void main(String[] args) {
        Transaction t = new Transaction();
        t.setSrcAmount(100);
        t.setSrcCurrency(Currency.EUR);
        t.setDstAmount(120);
        t.setDstCurrency(Currency.USD);
        System.out.println("" + t);
    }

}